package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.UserRoleDataDetail;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDataDetail_Grid_Main{
    private String userroledatadetailid;
    private String memo;
    private String userroledataid;
    private String updateman;
    private String userroledataname;
    private Integer isexclude;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    private String querymodelid;
    private String querymodelname;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    public  void fromUserRoleDataDetail(UserRoleDataDetail sourceEntity)  {
         this.setUserroledatadetailid(sourceEntity.getUserroledatadetailid());
         this.setMemo(sourceEntity.getMemo());
         this.setUserroledataid(sourceEntity.getUserroledataid());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setUserroledataname(sourceEntity.getUserroledataname());
         this.setIsexclude(sourceEntity.getIsexclude());
         this.setUpdatedate(sourceEntity.getUpdatedate());
         this.setQuerymodelid(sourceEntity.getQuerymodelid());
         this.setQuerymodelname(sourceEntity.getQuerymodelname());
         this.setSrfmajortext(sourceEntity.getUserroledatadetailname());
         this.setSrfdataaccaction(sourceEntity.getUserroledatadetailid());
         this.setSrfkey(sourceEntity.getUserroledatadetailid());
	}

	public static Page<UserRoleDataDetail_Grid_Main> fromUserRoleDataDetail(Page<UserRoleDataDetail> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<UserRoleDataDetail_Grid_Main> targetpage=new Page<UserRoleDataDetail_Grid_Main>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<UserRoleDataDetail_Grid_Main> records=new ArrayList<UserRoleDataDetail_Grid_Main>();
        for(UserRoleDataDetail source:sourcePage.getRecords()) {
            UserRoleDataDetail_Grid_Main target=new UserRoleDataDetail_Grid_Main();
            target.fromUserRoleDataDetail(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("userroledataname","数据对象能力"); }});
        columnModelList.add(new HashMap(){ { put("querymodelname","查询模型"); }});
        columnModelList.add(new HashMap(){ { put("isexclude","排除数据范围"); }});
        columnModelList.add(new HashMap(){ { put("memo","备注"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<UserRoleDataDetail> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(UserRoleDataDetail source:searchResult.getRecords()) {
            UserRoleDataDetail_Grid_Main target=new UserRoleDataDetail_Grid_Main();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<UserRoleDataDetail> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}